//------------------------------------------------------------------
#property copyright "free code"
#property link      "free code"
//+------------------------------------------------------------------
#property indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Gold
#property  indicator_color2  Magenta
#property  indicator_level1  70
#property  indicator_level2  50
#property  indicator_level3  30

//
//
//
//
//

extern int Price        = PRICE_CLOSE;
extern int FilterPeriod = 2;
extern int FilterMethod = 3;
extern int Rsi1Period   = 25;
extern int Ma1Period    = 30;
extern int Ma1Method    = MODE_LWMA;
extern int Rsi2Period   = 14;
extern int Ma2Period    = 14;
extern int Ma2Method    = MODE_SMA;

//
//
//
//
//

double rsi2[];
double rsi1[];
double ma1[];
double ma2[];
double fil[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,rsi2);
      SetIndexBuffer(1,ma2);
      SetIndexBuffer(2,rsi1);
      SetIndexBuffer(3,ma1);
      SetIndexBuffer(4,fil);
   IndicatorShortName("rsi + ma combination ("+FilterPeriod+","+Rsi1Period+","+Ma1Period+","+Rsi2Period+","+Ma2Period+")");
   return(0);
}
int deinit() { return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int i,limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--) fil[i]  = iMA(NULL,0,FilterPeriod,0,FilterMethod,Price,i);
   for(i=limit; i>=0; i--) rsi1[i] = iRapidRsi(fil[i],Rsi1Period,i,0);
   for(i=limit; i>=0; i--) ma1[i]  = iMAOnArray(rsi1,0,Ma1Period,0,Ma1Method,i);
   for(i=limit; i>=0; i--) rsi2[i] = iRapidRsi(ma1[i],Rsi2Period,i,1);
   for(i=limit; i>=0; i--) ma2[i]  = iMAOnArray(rsi2,0,Ma2Period,0,Ma2Method,i);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workRRsi[][2];
double iRapidRsi(double price, int period, int i, int instanceNo)
{
   if (ArrayRange(workRRsi,0) != Bars) ArrayResize(workRRsi,Bars); i=Bars-i-1;
   
   //
   //

   workRRsi[i][instanceNo] = price;
   
      double up   =0;
      double down =0;
      for(int k=0;  k<period && (i-k-1)>=0; k++)
      {
         double diff = workRRsi[i-k][instanceNo]-workRRsi[i-k-1][instanceNo];
         if(diff>0)
               up   += diff;
         else  down -= diff;
      }
      double rsi = 0; if((up+down) != 0) rsi = 100.0 * up / (up + down);
      return(rsi);
}